#ifndef RALEIGH_D_DIALOG_H
#define RALEIGH_D_DIALOG_H

#include <raleigh/w/vbox.h>
#include <raleigh/window.h>
#include <structs/alist.h>
#include <structs/duple.h>
#include <stdint.h>

namespace raleigh {
  typedef uint32_t diag_result_t;
  enum : diag_result_t {
    NONE = 0,
    YES,
    NO,
    CANCEL,
    RETRY
  };
  extern alist<duple<const char *, diag_result_t>> &yes_no_cancel;
  extern alist<duple<const char *, diag_result_t>> &yes_no_retry;
  class dialog : public window {
  public:
    //button names are copied
    //alist isn't needed past constructor
    dialog(widget &top_part, alist<duple<const char *, diag_result_t>> buttons);

    //zero means not set yet
    diag_result_t result;

    void show_modal();

  private:
    vbox *main_box;
  };
}

#endif